/***************************************************************************
 *   Copyright (C) 2008 by Daniel Nicoletti                                *
 *   dantti85-pk@yahoo.com.br                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef PK_K_AUTHORIZATIONS_H
#define PK_K_AUTHORIZATIONS_H

#include <KDialog>
#include <QSocketNotifier>

#include <polkit-dbus/polkit-dbus.h>

#include "PkKAction.h"

#include "ui_Authorizations.h"

class QSortFilterProxyModel;

namespace PkKAuthorization {

class AuthorizationsModel;

class Authorizations : public KDialog, Ui::Authorizations
{
Q_OBJECT

public:
    static Authorizations *instance();

    Authorizations(QWidget *parent = 0);
    ~Authorizations();

    void UpdateActionTree();

private slots:
    void actionClicked(const QModelIndex &index);
    void watchActivatedContext(int fd);

private:
    void PkKSetContext();

    PolKitContext *m_pkContext;
    AuthorizationsModel* m_model;
    QList<PolKitPolicyFileEntry *> *pkPFileEntry;

    PkKAction *m_pkKAction;
    QString m_currentActionId;

    static Authorizations *m_self;
    QMap<int, QSocketNotifier*> m_watches;
    QSortFilterProxyModel *m_proxyModel;
    static int add_context_io_watch(PolKitContext *context, int fd);
    static void remove_context_io_watch(PolKitContext *context, int fd);
    static void polkit_config_changed(PolKitContext* context, void* );
};


}

#endif
