/*  This file is part of the KDE project
    Copyright (C) 2008 Dario Freddi <drf54321@gmail.com>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.

*/

#ifndef AUTHORIZATIONSMODEL_H
#define AUTHORIZATIONSMODEL_H

#include <QStandardItemModel>

#include <polkit-dbus/polkit-dbus.h>

namespace PkKAuthorization
{

class TreeNode;

class AuthorizationsModel : public QStandardItemModel {
    Q_OBJECT
    public:
        enum {
            IdRole = 41,
            PolkitEntryRole = 42,
            EntryTypeRole = 43
        };

        enum EntryType {
            Group = 0,
            Action = 1
        };

        AuthorizationsModel(QObject* parent = 0);
        virtual ~AuthorizationsModel();

        void addEntry(PolKitPolicyFileEntry* entry, QStandardItem *parent = 0);

        PolKitPolicyFileEntry* polkitFileEntry(const QModelIndex &index);
        EntryType entryType(const QModelIndex &index);
        QString polkitId(const QModelIndex &index) const;

    /*private:
        QList<PolKitPolicyFileEntry* > m_entries;*/
};

}

Q_DECLARE_METATYPE(PolKitPolicyFileEntry*)

#endif
