/***************************************************************************
 *   Copyright (C) 2008 by Daniel Nicoletti                                *
 *   dantti85-pk@yahoo.com.br                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef PK_K_ACTION_H
#define PK_K_ACTION_H

#include <QStandardItemModel>

#include <polkit-dbus/polkit-dbus.h>

#include "ui_PkKAction.h"

namespace PkKAuthorization {

class PkKAction : public QWidget, Ui::PkKAction
{
Q_OBJECT

public:
    PkKAction(QWidget *parent = 0);
    ~PkKAction();

    void setPolKitPolicyFileEntry(PolKitPolicyFileEntry *pfe);

private slots:
    void on_allowAnyCB_currentIndexChanged(int index);
    void on_allowInactiveCB_currentIndexChanged(int index);
    void on_allowActiveCB_currentIndexChanged(int index);

    void on_modifyPB_clicked();
    void on_revertPB_clicked();

    void openUrl(const QString &url);

private:
    void checkDefaults();
    bool checkModified();

    QList<PolKitResult> resultsOrdered();
    PolKitPolicyFileEntry *m_pfe;
    QFont m_fontBold, m_fontNotBold;

    QStandardItemModel m_explicitSIM;

    PolKitPolicyDefault *m_defaults;
    PolKitResult m_defaultsAllowAny;
    PolKitResult m_defaultsAllowInactive;
    PolKitResult m_defaultsAllowActive;

    PolKitPolicyDefault *m_factory;
    PolKitResult m_factoryAllowAny;
    PolKitResult m_factoryAllowInactive;
    PolKitResult m_factoryAllowActive;
};


}

#endif
